import * as i0 from '@angular/core';
import { Directive, Input, Component, ChangeDetectionStrategy, ViewChild, NgModule } from '@angular/core';
import * as i1 from '@angular/material/menu';
import { _MatMenuTriggerBase, MatMenuModule } from '@angular/material/menu';
import * as i2 from '@angular/common';
import { CommonModule } from '@angular/common';

class NgxMatMenuTriggerDirective extends _MatMenuTriggerBase {
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    _handleClick(event) {
        // Nothing to do
    }
    get menu() {
        return super.menu;
    }
    set menu(menu) {
        super.menu = menu;
    }
}
NgxMatMenuTriggerDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.0", ngImport: i0, type: NgxMatMenuTriggerDirective, deps: null, target: i0.ɵɵFactoryTarget.Directive });
NgxMatMenuTriggerDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.1.0", type: NgxMatMenuTriggerDirective, selector: "[ngxMatMenuTriggerFor]", inputs: { menu: ["ngxMatMenuTriggerFor", "menu"] }, exportAs: ["ngxMatMenuTrigger"], usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.0", ngImport: i0, type: NgxMatMenuTriggerDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: `[ngxMatMenuTriggerFor]`,
                    exportAs: 'ngxMatMenuTrigger'
                }]
        }], propDecorators: { menu: [{
                type: Input,
                args: ['ngxMatMenuTriggerFor']
            }] } });

class NgxMatPopoverComponent {
    constructor(elementRef) {
        this.elementRef = elementRef;
        this.xPosition = 'after';
        this.yPosition = 'below';
        this.mode = 'toggle';
    }
    ngOnInit() {
        if (this.mode === 'toggle') {
            this.elementRef.nativeElement.addEventListener('click', () => this.ngxMatMenuTrigger.toggleMenu());
        }
        else {
            this.elementRef.nativeElement.addEventListener('mouseenter', () => this.ngxMatMenuTrigger.openMenu());
            this.elementRef.nativeElement.addEventListener('mouseleave', () => this.ngxMatMenuTrigger.closeMenu());
        }
    }
    open() {
        this.ngxMatMenuTrigger.openMenu();
    }
    close() {
        this.ngxMatMenuTrigger.closeMenu();
    }
}
NgxMatPopoverComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.0", ngImport: i0, type: NgxMatPopoverComponent, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component });
NgxMatPopoverComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.0", type: NgxMatPopoverComponent, selector: "ngx-mat-popover", inputs: { xPosition: "xPosition", yPosition: "yPosition", popoverContent: "popoverContent", mode: "mode" }, viewQueries: [{ propertyName: "ngxMatMenuTrigger", first: true, predicate: NgxMatMenuTriggerDirective, descendants: true, static: true }], exportAs: ["ngxMatPopover"], ngImport: i0, template: "<mat-menu #popover [xPosition]=\"xPosition\" [yPosition]=\"yPosition\" class=\"ngx-mat-popover\" [hasBackdrop]=\"false\">\n  <ng-template matMenuContent>\n    <span\n      mat-menu-item\n      [disableRipple]=\"true\"\n      (keydown.tab)=\"$event.stopPropagation()\"\n      (click)=\"$event.stopPropagation()\"\n      class=\"mat-popover\"\n    >\n      <!-- popover content begin -->\n      <ng-container *ngTemplateOutlet=\"popoverContent\"></ng-container>\n      <!-- popover content end  -->\n    </span>\n  </ng-template>\n</mat-menu>\n\n<div [ngxMatMenuTriggerFor]=\"popover\" #trigger=\"ngxMatMenuTrigger\">\n  <ng-content></ng-content>\n</div>\n", styles: ["::ng-deep .ngx-mat-popover{min-width:inherit;width:none!important;max-width:inherit!important}::ng-deep .ngx-mat-popover .mat-menu-item{height:auto;white-space:normal;line-height:inherit;display:flex;flex-direction:column;align-items:center;padding:1rem}::ng-deep .ngx-mat-popover .mat-menu-item.cdk-program-focused:not([disabled]),::ng-deep .ngx-mat-popover .mat-menu-item:hover:not([disabled]){background:inherit}::ng-deep .ngx-mat-popover .mat-menu-content{padding:0}\n"], components: [{ type: i1.MatMenu, selector: "mat-menu", exportAs: ["matMenu"] }, { type: i1.MatMenuItem, selector: "[mat-menu-item]", inputs: ["disabled", "disableRipple", "role"], exportAs: ["matMenuItem"] }], directives: [{ type: i1.MatMenuContent, selector: "ng-template[matMenuContent]" }, { type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: NgxMatMenuTriggerDirective, selector: "[ngxMatMenuTriggerFor]", inputs: ["ngxMatMenuTriggerFor"], exportAs: ["ngxMatMenuTrigger"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.0", ngImport: i0, type: NgxMatPopoverComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ngx-mat-popover', changeDetection: ChangeDetectionStrategy.OnPush, exportAs: 'ngxMatPopover', template: "<mat-menu #popover [xPosition]=\"xPosition\" [yPosition]=\"yPosition\" class=\"ngx-mat-popover\" [hasBackdrop]=\"false\">\n  <ng-template matMenuContent>\n    <span\n      mat-menu-item\n      [disableRipple]=\"true\"\n      (keydown.tab)=\"$event.stopPropagation()\"\n      (click)=\"$event.stopPropagation()\"\n      class=\"mat-popover\"\n    >\n      <!-- popover content begin -->\n      <ng-container *ngTemplateOutlet=\"popoverContent\"></ng-container>\n      <!-- popover content end  -->\n    </span>\n  </ng-template>\n</mat-menu>\n\n<div [ngxMatMenuTriggerFor]=\"popover\" #trigger=\"ngxMatMenuTrigger\">\n  <ng-content></ng-content>\n</div>\n", styles: ["::ng-deep .ngx-mat-popover{min-width:inherit;width:none!important;max-width:inherit!important}::ng-deep .ngx-mat-popover .mat-menu-item{height:auto;white-space:normal;line-height:inherit;display:flex;flex-direction:column;align-items:center;padding:1rem}::ng-deep .ngx-mat-popover .mat-menu-item.cdk-program-focused:not([disabled]),::ng-deep .ngx-mat-popover .mat-menu-item:hover:not([disabled]){background:inherit}::ng-deep .ngx-mat-popover .mat-menu-content{padding:0}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { xPosition: [{
                type: Input
            }], yPosition: [{
                type: Input
            }], popoverContent: [{
                type: Input
            }], mode: [{
                type: Input
            }], ngxMatMenuTrigger: [{
                type: ViewChild,
                args: [NgxMatMenuTriggerDirective, { static: true }]
            }] } });

class NgxMatPopoverModule {
}
NgxMatPopoverModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.0", ngImport: i0, type: NgxMatPopoverModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgxMatPopoverModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.1.0", ngImport: i0, type: NgxMatPopoverModule, declarations: [NgxMatMenuTriggerDirective, NgxMatPopoverComponent], imports: [CommonModule, MatMenuModule], exports: [NgxMatPopoverComponent] });
NgxMatPopoverModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.1.0", ngImport: i0, type: NgxMatPopoverModule, imports: [[CommonModule, MatMenuModule]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.0", ngImport: i0, type: NgxMatPopoverModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule, MatMenuModule],
                    declarations: [NgxMatMenuTriggerDirective, NgxMatPopoverComponent],
                    exports: [NgxMatPopoverComponent]
                }]
        }] });

/*
 * Public API Surface of ngx-mat-popover
 */

/**
 * Generated bundle index. Do not edit.
 */

export { NgxMatPopoverComponent, NgxMatPopoverModule };
//# sourceMappingURL=ngx-mat-popover.mjs.map
